org.apache.sysds.hops

## Class QuaternaryOp

- java.lang.Object
- - org.apache.sysds.hops.Hop
  - - org.apache.sysds.hops.MultiThreadedHop
    - - org.apache.sysds.hops.QuaternaryOp

All Implemented Interfaces:
  ParseInfo

    public class QuaternaryOp
    extends MultiThreadedHop

Note: this hop should be called AggQuaternaryOp in consistency with AggUnaryOp and AggBinaryOp; however, since there does not exist a real QuaternaryOp yet - we can leave it as is for now.

### Field Summary

Fields
`static boolean` `FORCE_REPLICATION`

### Fields inherited from class org.apache.sysds.hops.Hop

`_beginColumn, _beginLine, _endColumn, _endLine, _filename, _text, CPThreshold`

### Constructor Summary

Constructors
Constructor and Description
`QuaternaryOp(String l, Types.DataType dt, Types.ValueType vt, Types.OpOp4 o, Hop inX, Hop inU, Hop inV)`
`QuaternaryOp(String l, Types.DataType dt, Types.ValueType vt, Types.OpOp4 o, Hop inX, Hop inU, Hop inV, boolean flag1, boolean flag2)` Constructor for wsigmoid.
`QuaternaryOp(String l, Types.DataType dt, Types.ValueType vt, Types.OpOp4 o, Hop inW, Hop inU, Hop inV, boolean umult, Types.OpOp1 uop, Types.OpOp2 sop)`
`QuaternaryOp(String l, Types.DataType dt, Types.ValueType vt, Types.OpOp4 o, Hop inX, Hop inU, Hop inV, Hop inW, boolean post)` Constructor for wsloss.
`QuaternaryOp(String l, Types.DataType dt, Types.ValueType vt, Types.OpOp4 o, Hop inX, Hop inU, Hop inV, Hop inW, int baseType, boolean flag1, boolean flag2)`

### Method Summary

All Methods Instance Methods Concrete Methods
`boolean` `allowsAllExecTypes()`
`void` `checkArity()` Check whether this Hop has a correct number of inputs.
`Object` `clone()`
`boolean` `compare(Hop that)`
`Lop` `constructLops()`
`Types.OpOp4` `getOp()`
`String` `getOpString()`
`boolean` `isGPUEnabled()` In memory-based optimizer mode (see OptimizerUtils.isMemoryBasedOptLevel()), the exectype is determined by checking this method as well as memory budget of this Hop.
`boolean` `isMultiThreadedOpType()`
`void` `refreshSizeInformation()` Update the output size information for this hop.

### Methods inherited from class org.apache.sysds.hops.MultiThreadedHop

`getMaxNumThreads, setMaxNumThreads`

### Methods inherited from class org.apache.sysds.hops.Hop

`addAllInputs, addInput, checkAndSetForcedPlatform, checkAndSetInvalidCPDimsAndSize, clearMemEstimate, colsKnown, compressedSize, computeBoundsInformation, computeBoundsInformation, computeBoundsInformation, computeMemEstimate, computeSizeInformation, computeSizeInformation, computeSizeInformation, constructAndSetLopsDataFlowProperties, createOffsetLop, dimsKnown, dimsKnown, dimsKnownAny, federatedCostInitialized, getBeginColumn, getBeginLine, getBlocksize, getCompressedSize, getDataCharacteristics, getDataType, getDim, getDim1, getDim2, getEndColumn, getEndLine, getExecType, getFederatedCost, getFilename, getForcedExecType, getHopID, getInput, getInput, getInputMemEstimate, getInputMemEstimate, getInputOutputSize, getIntermediateMemEstimate, getLength, getLops, getMemEstimate, getName, getNnz, getOutputMemEstimate, getOutputMemEstimate, getParent, getPrivacy, getSparsity, getSpBroadcastSize, getText, getUpdateType, getValueType, hasCompressedInput, hasFederatedOutput, hasLocalOutput, hasMatrixInputWithDifferentBlocksizes, hasValidCPDimsAndSize, isCompressedOutput, isFederated, isFederatedDataOp, isMatrix, isMemEstimated, isOutputEmptyBlocks, isRequiredDecompression, isScalar, isTransposeSafe, isVisited, printErrorLocation, refreshColsParameterInformation, refreshColsParameterInformation, refreshMemEstimates, refreshRowsParameterInformation, refreshRowsParameterInformation, requiresCheckpoint, requiresCompression, requiresLineageCaching, requiresReblock, requiresRecompile, resetExecType, resetRecompilationFlag, resetRecompilationFlag, resetVisitStatus, resetVisitStatus, resetVisitStatus, resetVisitStatusForced, rowsKnown, setBeginColumn, setBeginLine, setBlocksize, setCompressedOutput, setCompressedSize, setDataType, setDim, setDim1, setDim2, setEndColumn, setEndLine, setExecType, setFederatedCost, setFederatedOutput, setFilename, setForcedExecType, setLops, setMemEstimate, setName, setNnz, setOutputEmptyBlocks, setParseInfo, setPrivacy, setRequiresCheckpoint, setRequiresCompression, setRequiresCompression, setRequiresDeCompression, setRequiresLineageCaching, setRequiresReblock, setRequiresRecompile, setText, setUpdateType, setValueType, setVisited, setVisited, someInputFederated, toString`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface org.apache.sysds.parser.ParseInfo

`ctxAndFilenameToParseInfo`

### Field Detail

#### FORCE_REPLICATION

    public static boolean FORCE_REPLICATION

### Constructor Detail

#### QuaternaryOp

    public QuaternaryOp(String l,
                        Types.DataType dt,
                        Types.ValueType vt,
                        Types.OpOp4 o,
                        Hop inX,
                        Hop inU,
                        Hop inV,
                        Hop inW,
                        boolean post)

Constructor for wsloss.

Parameters:
  `l` - ?
  `dt` - data type
  `vt` - value type
  `o` - the Hop.OpOp4
  `inX` - high-level operator X
  `inU` - high-level operator U
  `inV` - high-level operator V
  `inW` - high-level operator W
  `post` - post weights

#### QuaternaryOp

    public QuaternaryOp(String l,
                        Types.DataType dt,
                        Types.ValueType vt,
                        Types.OpOp4 o,
                        Hop inX,
                        Hop inU,
                        Hop inV,
                        boolean flag1,
                        boolean flag2)

Constructor for wsigmoid.

Parameters:
  `l` - ?
  `dt` - data type
  `vt` - value type
  `o` - the Hop.OpOp4
  `inX` - high-level operator X
  `inU` - high-level operator U
  `inV` - high-level operator V
  `flag1` - logout
  `flag2` - minusin

#### QuaternaryOp

    public QuaternaryOp(String l,
                        Types.DataType dt,
                        Types.ValueType vt,
                        Types.OpOp4 o,
                        Hop inX,
                        Hop inU,
                        Hop inV,
                        Hop inW,
                        int baseType,
                        boolean flag1,
                        boolean flag2)

#### QuaternaryOp

    public QuaternaryOp(String l,
                        Types.DataType dt,
                        Types.ValueType vt,
                        Types.OpOp4 o,
                        Hop inW,
                        Hop inU,
                        Hop inV,
                        boolean umult,
                        Types.OpOp1 uop,
                        Types.OpOp2 sop)

#### QuaternaryOp

    public QuaternaryOp(String l,
                        Types.DataType dt,
                        Types.ValueType vt,
                        Types.OpOp4 o,
                        Hop inX,
                        Hop inU,
                        Hop inV)

### Method Detail

#### checkArity

    public void checkArity()

Description copied from class: `Hop`
Check whether this Hop has a correct number of inputs. (Some Hops can have a variable number of inputs, such as DataOp, DataGenOp, ParameterizedBuiltinOp, ReorgOp, TernaryOp, QuaternaryOp, MultipleOp, DnnOp, and SpoofFusedOp.) Parameterized Hops (such as DataOp) can check that the number of parameters matches the number of inputs.

Specified by:
  `checkArity` in class `Hop`

#### getOp

    public Types.OpOp4 getOp()

#### isGPUEnabled

    public boolean isGPUEnabled()

Description copied from class: `Hop`
In memory-based optimizer mode (see OptimizerUtils.isMemoryBasedOptLevel()), the exectype is determined by checking this method as well as memory budget of this Hop. Please see findExecTypeByMemEstimate for more detail. This method is necessary because not all operator are supported efficiently on GPU (for example: operations on frames and scalar as well as operations such as table).

Specified by:
  `isGPUEnabled` in class `Hop`
Returns:
  true if the Hop is eligible for GPU Exectype.

#### isMultiThreadedOpType

    public boolean isMultiThreadedOpType()

Specified by:
  `isMultiThreadedOpType` in class `MultiThreadedHop`

#### constructLops

    public Lop constructLops()

Specified by:
  `constructLops` in class `Hop`

#### getOpString

    public String getOpString()

Specified by:
  `getOpString` in class `Hop`

#### allowsAllExecTypes

    public boolean allowsAllExecTypes()

Specified by:
  `allowsAllExecTypes` in class `Hop`

#### refreshSizeInformation

    public void refreshSizeInformation()

Description copied from class: `Hop`
Update the output size information for this hop.

Specified by:
  `refreshSizeInformation` in class `Hop`

#### clone

    public Object clone()
                 throws CloneNotSupportedException

Specified by:
  `clone` in class `Hop`
Throws:
  `CloneNotSupportedException`

#### compare

    public boolean compare(Hop that)

Specified by:
  `compare` in class `Hop`